#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# MIT License
#
# Copyright (c) 2020 Cesar Pereida García, Sohaib ul Hassan, Nicola Tuveri,
# Iaroslav Gridin, Alejandro Cabrera Aldaya, Billy Bob Brumley
#
# Copyright (c) 2020 Sohaib ul Hassan, Iaroslav Gridin,
# Ignacio M. Delgado-Lozano, Cesar Pereida García, Jesús-Javier Chi-Domínguez,
# Alejandro Cabrera Aldaya, Billy Bob Brumley
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

import sys
import ijson
import json

try:
    target = int(sys.argv[2])
    fp = open(sys.argv[1], 'rb')
except:
    print('Usage: python2 %s <path_to_json> <index>' % (sys.argv[0]))
    sys.exit(1)

idx = -1

for v in ijson.items(fp, 'item'):
    idx += 1
    if idx != target: continue
    print(json.dumps(v))
    break

fp.close()

