#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# MIT License
#
# Copyright (c) 2020 Cesar Pereida García, Sohaib ul Hassan, Nicola Tuveri,
# Iaroslav Gridin, Alejandro Cabrera Aldaya, Billy Bob Brumley
#
# Copyright (c) 2020 Sohaib ul Hassan, Iaroslav Gridin,
# Ignacio M. Delgado-Lozano, Cesar Pereida García, Jesús-Javier Chi-Domínguez,
# Alejandro Cabrera Aldaya, Billy Bob Brumley
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

import sys
import ijson

try:
    fp = open(sys.argv[1], 'rb')
except:
    print('Usage: python3 %s <path_to_json>' % (sys.argv[0]))
    sys.exit(1)

d = {}

for v in ijson.items(fp, 'item'):
    latency = int(v['latency'])
    y = v['y']
    g = v['g']
    h = v['h']
    k = v['k']
    q = v['q']
    p = v['p']
    s = v['s']
    r = v['r']
    msg = v['msg']
    x = v['x']
    id = v['id']
    k_len = int(v['k_len'])
    if k_len not in d:
        d[k_len] = []
    d[k_len].append(latency)

fp.close()

print('Len\tMedian')

# latency is clock cycles; scale to ms at 3.1 GHz
SCALE=3100000.0

for bit in sorted(d.keys()):
    d[bit].sort()
    print('%d\t%0.1f' % (bit, d[bit][len(d[bit])//2] / SCALE))
